<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Shadow</title>
    <style>

        body {
        @include display(flex);
        @include align-content(center);
            color: #353535;
            min-height: 100vh;
            font-family: 'Open Sans', sans-serif;
            font-size: 4px;
            text-align: center;
            background-color: lightgreen;
            margin: 0 auto;
            overflow: hidden;
        }

        .container {
            background-color: white;
            box-shadow: 0 0 4px 1px #BBB;
            text-align: center;
            width: 100%;
            height: 100%;
        }

        #web-gl {
            height: 100%;
            width: 100%;
        }
    </style>
    <script type="text/javascript" src="lib/three.js"></script>
    <script type="text/javascript" src="lib/ShadowMapViewer.js"></script>
    <script type="text/javascript" src="lib/dat.gui.min.js"></script>
    <script type="text/javascript" src="lib/GPUParticleSystem.js"></script>
</head>
<body>
<div class="container">
    <div id="web-gl">
    </div>
</div>
<script id="scriptScene0" type="text/javascript">

    //  Basic Variables
    var camera, renderer, clock = new THREE.Clock();
    var tick = 0;

    //  Shape Variables
    var scene;
    var options, spawnerOptions, particleSystem;

    init();
    animate();

    function init() {

        scene = new THREE.Scene();
        camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.1, 1000);
        camera.position.z = 100;

        renderer = new THREE.WebGLRenderer({antialias: true});
        renderer.setClearColor(new THREE.Color(0x000000));
        renderer.setSize(window.innerWidth, window.innerHeight);
        renderer.setSize(window.innerWidth, window.innerHeight);

        document.getElementById("web-gl").appendChild(renderer.domElement);

        ambientLight = new THREE.AmbientLight(0xffffff); // soft yellow light
        scene.add(ambientLight);

        particleSystem = new THREE.GPUParticleSystem({maxParticles: 250000});
        scene.add(particleSystem);

        options = {
            position: new THREE.Vector3(),
            positionRandomness: .3,
            velocity: new THREE.Vector3(),
            velocityRandomness: .5,
            color: 0xaa88ff,
            colorRandomness: .2,
            turbulence: .5,
            lifetime: 2,
            size: 5,
            sizeRandomness: 1
        };
        spawnerOptions = {
            spawnRate: 15000,
            horizontalSpeed: 1.5,
            verticalSpeed: 1.33,
            timeScale: 1
        };
    }

    function animate() {

        requestAnimationFrame(animate);

        var delta = clock.getDelta() * spawnerOptions.timeScale;
        tick += delta;
        if (tick < 0) tick = 0;
        if (delta > 0) {
            options.position.x = Math.sin(tick * spawnerOptions.horizontalSpeed) * 20;
            options.position.y = Math.sin(tick * spawnerOptions.verticalSpeed) * 5;
            options.position.z = Math.sin(tick * spawnerOptions.horizontalSpeed + spawnerOptions.verticalSpeed) * 5;
            for (var x = 0; x < spawnerOptions.spawnRate * delta; x++) {
                // Yep, that's really it.	Spawning particles is super cheap, and once you spawn them, the rest of
                // their lifecycle is handled entirely on the GPU, driven by a time uniform updated below
                particleSystem.spawnParticle(options);
            }
        }
        particleSystem.update(tick);

        renderer.render(scene, camera);
    }
</script>
</body>
</html>